'''
Created on 24.06.2011

@author: chris
'''
import pymunk
import pygame
import Utils
from pymunk.vec2d import Vec2d

COLLISION_ID = 42

class Box(pymunk.Poly):
    def __init__(self, (width, height), (posX, posY), polarity):
        
        #1 positive, 0 neutral, -1 negativ
        self.polarity = polarity
        self.fieldStrength = 100
        
        mass = 1
        moment = pymunk.moment_for_box(mass, width, height)
        halfWidth = int(width/2)
        halfHeight = int(height/2)
        box_points = [(-halfWidth, -halfHeight), 
                      (-halfWidth, halfHeight), 
                      (halfWidth,halfHeight), 
                      (halfWidth, -halfHeight)]
        body = pymunk.Body(mass, moment)
        body.position = posX, posY
        
        pymunk.Poly.__init__(self, body, box_points)
        
        self.friction = .42
        self.collision_type = COLLISION_ID
        
        #self.rect.ip_move(posX, posY)
        
    """        
    def create_box(self, pos, size = 10, mass = 5.0):
        #constructed arround center
        box_points = [(-size, -size), (-size, size), (size,size), (size, -size)]
        return self.create_poly(box_points, mass = mass, pos = pos)

    def create_poly(self, points, mass = 5.0, pos = (0,0)):
          
        moment = pm.moment_for_poly(mass,points, Vec2d(0,0))    
        #moment = 1000
        body = pm.Body(mass, moment)
        body.position = Vec2d(pos)       
        
        shape = pm.Poly(body, points, Vec2d(0,0))
        shape.friction = 0.5
        shape.collision_type = COLLTYPE_DEFAULT
        self.space.add(body, shape)
        return shape
    """

    def draw(self, surface, scrollPosition):
       
        points = self.get_points()
        points = [x - scrollPosition for x in points]
        points = map(Utils.flipyv, points) #apply function to all elements of list
        pygame.draw.polygon(surface, Utils.colors[self.polarity], points)
        
        
        #draw center 
        #pos = Utils.to_pygame(self.body.position)
        #pygame.draw.circle(surface, pygame.Color("red"), pos, 1)
        
        #draw force
        #pygame.draw.line(surface, pygame.Color("green"), 
        #                 Utils.to_pygame(self.body.position), 
        #                 self.body.force)
        

class FixBox(pymunk.Poly):
    def __init__(self, space, (width, height), bottomleft, polarity):
        self.polarity = polarity
        self.fieldStrength = 100
        self.bottomleft = Vec2d(bottomleft)
        self.width = width
        self.height = height
        
        halfWidth = (self.width)/2
        halfHeight = (self.height)/2
        
        body = pymunk.Body(pymunk.inf, pymunk.inf)
        body.position = (self.bottomleft.x + halfWidth,
                         self.bottomleft.y + halfHeight)
        
        box_points = [(-halfWidth, -halfHeight), 
                      (halfWidth, -halfHeight), 
                      (halfWidth,halfHeight), 
                      (-halfWidth, halfHeight)]
        pymunk.Poly.__init__(self, body, box_points)
        
        self.friction = .42
        self.collision_type = COLLISION_ID
        space.add_static(self)
    
    def draw(self, surface, scrollPosition):
        color = Utils.colors[self.polarity]
        bottomleft = self.bottomleft - scrollPosition
        pygame.draw.rect(surface,
            color,
            pygame.Rect(Utils.flipyv(bottomleft + (0, self.height)),
                        (self.width, self.height))
            )
