'''
Created on 24.06.2011

@author: neo
'''
import pymunk
import pygame
from SupraBall import Utils
from pymunk.vec2d import Vec2d

class Groove:

    def __init__(self, space, a, b):
        '''
        space
        a, b endpoints of the groove
        '''
        self.a = a = Vec2d(a)
        self.b = b = Vec2d(b)
        self.space = space
        
        self.body = pymunk.Body(pymunk.inf, pymunk.inf)
        self.body.position = ((a.x + b.x)/2, (a.y + b.y)/2)
        #self.segment = pymunk.Segment(self.body, (-300,0), (300,0), 2)
        #space.add(self.body)#, self.segment)
        
    def add(self, body, fixpoint):
        joint = pymunk.GrooveJoint(self.body,
                                   body,
                                   self.body.world_to_local(self.a),
                                   self.body.world_to_local(self.b),
                                   fixpoint)
        self.space.add(joint)
        return joint
    
    def remove(self, joint):
        self.space.remove(joint)
    
    def draw(self, surface):
        color = (255, 255, 0)
        pygame.draw.line(surface,
                         color,
                         Utils.to_pygame(self.a),
                         Utils.to_pygame(self.b))
